#ifndef __PENGUIN_ZONE_HEURISTIC_FREEDOM_HPP__
#define __PENGUIN_ZONE_HEURISTIC_FREEDOM_HPP__

#include "penguin.hpp"
#include "heuristic.hpp"
#include "penguin_heuristic.hpp"
#include <algorithm>

namespace mcts
{
  class zone_heuristic : public penguin_heuristic
  {
  public:
    float get_value(const game::penguin& game, uint8_t move) const 
    {
		
		game::penguin g = *(game::copy(game));
		g.play(move);
		auto s = g.get_state();
		uint32_t* penguins = s.current_player_red ? s.peng_red : s.peng_blue;
		uint32_t* other_peng = s.current_player_red ? s.peng_blue : s.peng_red;
		
		//uint64_t obstacles = g.create_obstacles_bitboard();
		uint64_t moves_this = 0;
		uint64_t moves_other = 0;
		//for(int i = 0; i < 4; ++i) {
			//g.update_penguin_moves(&other_peng[i],obstacles);
			//g.update_penguin_moves(&penguins[i],obstacles);
		//}
		//std::cout << "CURRENT PLAYER RED : " << s.current_player_red << std::endl;
		//std::cout << "NB MOVES RED : " << s.nb_moves_red << std::endl;
		//std::cout << "NB MOVES BLUE : " << s.nb_moves_blue << std::endl;
		for(int i = 0; i < 4; ++i) {
			moves_this 	|= g.penguin_move_board(penguins[i]);
			moves_other |= g.penguin_move_board(other_peng[i]);	
		}
		uint64_t this_owned_moves = moves_this & ~(moves_other);
		uint64_t other_owned_moves = moves_other & ~(moves_this);
		
		int count_this = 0;
		int count_other = 0;
		for(int i = 0; i < 60; i++) {
			count_this += (this_owned_moves>>i) & 1 ;
			count_other += (other_owned_moves>>i) & 1 ;
		}
		//std::cout << "COUNT_THIS : " << count_this << std::endl;
		//std::cout << "COUNT_OTHER : " << count_other << std::endl;
		
		//std::cout << clamp((float)(count_this - count_other) / (count_this + 1), -1.f, 1.f) << std::endl;
		return clamp((float)(count_this - count_other) / (count_this + 1), -1.f, 1.f);
		
		
	}
    int get_count(const game::penguin& game, uint8_t move) const
    {
		return 100;
	}
	
private:
	float clamp(float v, float l, float h) const
	{
		return std::max(std::min(h,v),l);
	}
  };
};

#endif
